#include <bits/stdc++.h>
using namespace std;
typedef vector<vector<string>> vvs;
typedef vector<vector<int>> vvi;
typedef vector<int> vi;
int T,M,N;

void merge_print_map(vvs &map_anim, vvs &map_soil){
    for(int i = M-1;i>=0;i--){
        for (int j = 0; j < N; j++)
        {
            if(map_anim[i][j] != ""){
                cout << map_anim[i][j];
            }else
            {
                cout << map_soil[i][j];
            }
            
        }
        cout << ""<< endl;
    }
    
}

void print_map(vvs &  map){
    for(int i = map.size()-1;i>=0;i--){
        for(int j= 0; j < N;j++){
            cout << map[i][j];
            // cout << i;
        }
        cout << endl;
    }
}


int find_idx(int y,int x,vvi vec){
    int idx = -1;
    for(int i = 0;i<vec.size();i++){
        if(vec[i][0] == y && vec[i][1] == x){
            idx = i;
            break;
        }
    }
    return idx;
}

vvi new_vec(vvi old, vi rem_idx){
    vvi new_vec;
    for(int i=0;i<old.size();i++){
        bool keep = true;
        for(int idx:rem_idx){
            if(idx == i){
                keep = false;
                break;
            }
        }

        if(keep){
            new_vec.push_back({old[i][0],old[i][1],old[i][2]});
        }
    }
    return new_vec;
}

void print_vec(vvi &v){
    for(auto a:v){
        for(auto b:a){
            cout << b;
        }
        cout << endl;
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin >> T >> M >> N;
    vvs map_anim(M,vector<string>(N," "));
    vvs map_soil(M,vector<string>(N," "));
    vvi wolves;
    vvi sheeps;
    vvi soils;


    // merge_print_map(map_anim,map_soil);
    int baf = 1;
    for(int i=M-1;i>0;i--){
        // vector<string> rw(10);
        // cin >> rw[0];
        string a;
        cin >> a;
        for(int j =0;j<N;j++){
            string tmp = a.substr(j,1);
            if(tmp =="W"){
                wolves.push_back({i,j,10});
                map_anim[i][j] ="W";
                map_soil[i][j] =".";
                soils.push_back({i,j,baf});
            }else if(tmp == "S"){
                sheeps.push_back({i,j,5});
                map_anim[i][j] = "S";
                map_soil[i][j] =".";
                soils.push_back({i,j,baf});
            }else if(tmp =="."){
                map_soil[i][j] = ".";
                soils.push_back({i,j,baf});
            }else if(tmp=="*"){
                map_soil[i][j] = "*";
            }else if(tmp == "#"){
                map_soil[i][j] = "#";
            }else{
                cout <<"WEROR";
            }
        }
    }

    // print_vec(new_vec(sheeps,vi{0}))
    // cout << "A";

    // merge_print_map(map_anim,map_soil);
    // print_map(map_soil);
    // cout << "A";
    // print_map(map_anim);
    for(int timestep = 0;timestep<T;timestep++){
    // main loop
    //step 1
    //wolves
        for(vi &wolf:wolves){
            map_anim[wolf[0]][wolf[1]] = "";
            wolf[1]++;
            if(wolf[1]>= N){
                wolf[1] = 0;
            }
            map_anim[wolf[0]][wolf[1]] = "W";

        }
        //sheep
        for(vi &sheep:sheeps){
            map_anim[sheep[0]][sheep[1]] = "";
            sheep[0]--;
            if(sheep[0]<0){
                sheep[0] = M-1;
            }

            if(map_anim[sheep[0]][sheep[1]] == "W"){
                map_anim[sheep[0]][sheep[1]] = "K";
            }else{
                map_anim[sheep[0]][sheep[1]] = "S";
                // cout << sheep[0] << sheep[1];
            }

        }

        // print_map(map_anim);
        
        //Step2
        for(int y =0;y<M;y++){
            for(int x=0;x<N;x++){
                if(map_anim[y][x] == "K"){
                    int sheep_id = find_idx(y,x,sheeps);
                    int wolf_id = find_idx(y,x,wolves);
                    int soil_id = find_idx(y,x,soils);

                    //remove vec
                    sheeps = new_vec(sheeps,vi{sheep_id});
                    wolves[wolf_id][2]=10;
                    map_anim[y][x]="W";
                    if(soil_id != -1){
                        soils = new_vec(soils,vi{soil_id});
                    }
                    map_soil[y][x] = "*";
                }
            }
        }

        //Step3
        for(int i =0;i<sheeps.size();i++){
            if(map_soil[sheeps[i][0]][sheeps[i][1]] == "#"){
                map_soil[sheeps[i][0]][sheeps[i][1]] = ".";
                soils.push_back({sheeps[i][0],sheeps[i][1],0});
                sheeps[i][2] = 5;
            }
        }

        //sStep4
        for(int i = 0;i<wolves.size();i++){
            // vi &wolf = wolves[i];
            if(wolves[i][2]==0){
                if(map_soil[wolves[i][0]][wolves[i][1]] == "."){
                    int soils_id = find_idx(wolves[i][0],wolves[i][1],soils);
                    soils = new_vec(soils,vi{soils_id});
                }
                map_soil[wolves[i][0]][wolves[i][1]] = "*";
            }
            wolves[i][2]--;
        }

        //Step5
        for(int i = 0;i<sheeps.size();i++){
            // vi &sheep = sheeps[i];
            if(sheeps[i][2]==0){
                if(map_soil[sheeps[i][0]][sheeps[i][1]] == "."){
                    int soils_id = find_idx(sheeps[i][0],sheeps[i][1],soils);
                    soils = new_vec(soils,vi{soils_id});
                }
                map_soil[sheeps[i][0]][sheeps[i][1]] = "*";
            }
            sheeps[i][2]--;
        }

        // print_vec(soils);
        
        //Step 6
        for(int i=0;i<soils.size();i++){
            // cout << "A";
            
            // vi &soil = soils[i];
            if(soils[i][2]==3){
                map_soil[soils[i][0]][soils[i][1]] = "#";
                soils = new_vec(soils,vi{i});
                
                
            }else{
                soils[i][2]++;
            }
        }

        // cout << soils.size() << endl;

        // print_vec(soils);

        // print_map(map_anim);
        cout << "_______" << endl;

        // for(auto a:sheeps){
        //     for(auto b:a){
        //         cout << b;
        //     }
        //     cout << endl;
        // }

        merge_print_map(map_anim,map_soil);

        // cout << "A" << endl;
    }
    
}